require "./mysql"

######################################################################
#
# Simple Online Questionaire handling script.
#   This is MySQL database connectivity
#
# Done for the subject "Marketing and Entrepreneurship"
# group 13, spring 2001
#
# @author Kent Dahl 
#               @email  kentda@stud.ntnu.no 
#               @email  MenThal@bigfoot
#
# Copyright 2001 Kent Dahl. All rights reserved.
# This software is Open Source. 
#
######################################################################


class MarkedDB
        attr_reader :con

  DEBUG = ::DEBUG

  DATABASE_PREFIX = "kentda_"

  SERVER   = "mysql.database.at.some.domainname"  #FIX ME
  USER     = DATABASE_PREFIX + ::USER
  PASSWD   = ::PASSWD 
  DATABASE = DATABASE_PREFIX+"test_1"
  

  # use different tables depending wheter it is release.
  if ::RELEASE_VERSION
	TABLE_PREFIX = "main_"
  else
	TABLE_PREFIX = "main_"
  end

  
  SVAR     = TABLE_PREFIX+"svar"
  METASVAR = TABLE_PREFIX+"metasvar"

  METASVAR_INSERT_1 = "insert into " + METASVAR + 
                "( session, tilstand, dato, ansvarlig) values ( " 

  METASVAR_INSERT_2 = ",0,NOW(), 0)"

  METASVAR_GET_ID = "select id from " + METASVAR +
                " where tilstand=0 and session="





  def initialize
                @con = Mysql.new(  SERVER, USER, PASSWD, DATABASE )
  end

  # returns the id
  def insert
        begin
        session = rand( Time.now.to_i ).to_s
        work = METASVAR_INSERT_1 + session.to_s +  METASVAR_INSERT_2
        print "<BR>"+work if DEBUG
        res = @con.query( work ) #insert it


        work = METASVAR_GET_ID + session
        print "<BR>"+work if DEBUG
        res = @con.query( work ) #fetch the id
        print "Got it"             if DEBUG
        newId = -999
        res.each do |row|
                puts row.join("\t") if DEBUG
                newId = row[0].to_i
        end

        if newId<0 then print "Oh BUGGER!" end


        work = "insert into " + SVAR + " (id) " +
                " values ( " + newId.to_s + ")"
        res = @con.query( work )



        # update the state
        work = "update " +METASVAR+ " set tilstand=1 where id=" +newId.to_s
         print "<P>"+work if DEBUG
         res = @con.query( work )
        

        rescue StandardError => boom
                print "StandardError:" + boom
        end

        newId #return value

  end




  def updateSvar( id, svar )
        svar.values["id"] = id.to_s

        work = "update "+SVAR+" set "
        nextwork = work
        svar.values.each{|k,v|
                print "<BR>" +k.to_s+ "---" +v.to_s             if DEBUG
                work = nextwork+ k.to_s+"="+v.to_s
                nextwork = work+", "
        }
        #labels = svar.values.keys.join(", ")
        #print labels
        #values = svar.values.values.join(", ")
        #print "<P>("+labels+")=>"+values + " | "+work


        
        work = work + " where id=" + id.to_s
        
        print "<P>"+work             if DEBUG
        res = @con.query( work )
        print "...done! "               if DEBUG

  end

  def updateMetaSvar( id, svar )
        #svar.values["id"] = id.to_s

        if !svar.values.empty? then

        work = "update "+METASVAR+" set "
        nextwork = work
        svar.values.each{|key,v|
                k = key.to_s
                k = k.gsub("META_","")
                print "<BR>" +k.to_s+ "---" +v.to_s             if DEBUG
                work = nextwork+ k.to_s+"="+v.to_s
                nextwork = work+", "
        }
        #labels = svar.values.keys.join(", ")
        #print labels
        #values = svar.values.values.join(", ")
        print "<P>updateMetaSvar: "+work                if DEBUG


        
        work = work + " where id=" + id.to_s
        
        print "<P>"+work             if DEBUG
        res = @con.query( work )
        end
  end



  def showTable( table )

        print "<H2>" + table.to_s +  "</H2><TABLE border=1><TR>"
        @con.list_fields(table).fetch_fields.each do |f|
                print "<TH>"+ f.name.to_s + "</TH>"
        end    

        res = @con.query("select * from "+table)
        res.each do |row|
            print "<TR><TD>" + row.join("<TD>")
        end

        print "</TABLE>"           
  end




  def close

  end


end
