#!/store/bin/ruby 

######################################################################
#
# Simple Online Questionaire handling script.
#   This is the main logic, somewhat loosely hacked together.
#   Some parts are reusable, others tied to the application.
#
# Done for the subject "Marketing and Entrepreneurship"
# group 13, spring 2001
#
# @author Kent Dahl 
#               @email  kentda@stud.ntnu.no 
#               @email  MenThal@bigfoot
#
# Copyright 2001 Kent Dahl. All rights reserved.
# This software is Open Source. 
#
######################################################################

print "Content-type: text/html\r\n\r\n"
# print "SAFE=" + $SAFE.to_s

require "cgi"
require "socket"

# Global stuff. 
# Remember to make this file NON READABLE and use wrapper
# to increase security. Password and user to be added here


USER = "demo"
PASSWD = "somepasswordofcourse" #FIX ME


#########################

DEBUG = false


require "./questionform_config.rb"




#if DEBUG then#
#
#  # DEBUG_LOG = File.new("~kentda/upload/debuglog", "w")#
#
#  def print( x )
#	log( x )
#	super
#  end

#  def log( x )
#	DEBUG_LOG << x << "\n"
#	DEBUG_LOG.flush
#  end
#else
 def log(x)
 end	
#end

log("pre svarXXXXX")



#_________________________________
 require "./svar.rb"
#_________________________________


#_________________________________
require "./data.rb"
#_________________________________





class MissingFieldsException < RuntimeError
  attr_reader :fields
  def initialize( fields )
        @fields = fields
  end
end



class Marked < SvarBase
	attr_reader :data, :metadata, :ctrldata, :params

        DEBUG = ::DEBUG

	def initialize()
		@data = Svar.new
		@metadata = MetaSvar.new
		@ctrldata = ControlParams.new	

		@replacepattern = /<%QUESTIONFORM \w+ %>/ 
		@wordpattern = / \w+ /

	end


	def add(k,v)
		@values[k]=v
	end


  def do( cgi )
	param = cgi.params
	@params = param


	action = param["CTRL_action"]

	#print "<P>Action=#{action.to_s}</P>" if action

	#action = (action.to_s ~= "CTRL_action")


	if action.empty? then
		print "<html><title>Echo Paramters</title><body>"
		print "<H1>Echo Parameters!</H1>"
		echo( param )

		print "</body></html>\r\n"
	end

	param.each{ |k, v|
		key = k.to_s
		val = v.to_s

		isMeta = isMeta?(key) 
		isControl = isControl?(key) 

		d = @data
		d = @metadata if isMeta
		d = @ctrldata if isControl

		#print "#{key} to:#{d.id.to_s}; <BR>"
		d.add(key,val)

	}	
	#print "..."
	#print @data.values.to_a.join("-")



	if !action.empty? then
		action_id = action[0].to_s.to_i
		doAction( action_id )
	end
		
  end


  def getReplaceValue( s )
        x = @data.values[s]
        x = @metadata.values[s] if x==nil
        x = @ctrldata.values[s] if x==nil
        x = @params[s]          if x==nil
                # x = ENV[s]              if x==nil
        x = x.to_s              if x!=nil
        x
  end


  def processLine( line )
	match = line.scan( @replacepattern )
	if !match.empty? then
		s = match.to_s.scan( @wordpattern ).to_s.strip
		newValue = getReplaceValue( s )
		line = line.gsub( @replacepattern, newValue )
	end
	line
  end

  def doAction( action )
        case action
	        when 1 then
                        begin 
                                print "<P> Pre update" if DEBUG
                                updateDatabase
                                print "<P> Post update" if DEBUG
                                feedfileout( @ctrldata.values["CTRL_page"] )

                        rescue MissingFieldsException => missingFields
                                print "MISSING FIELDS!!!!!" if DEBUG
                                notifyAboutMissingFields( missingFields.fields )
                        end

	        when 2 then 
                        feedfileout( @ctrldata.values["CTRL_page"] )
                when 101 then
                        showAllTables
                when 0 then
                        echoParams( @params )
                        
        end

  end

  def updateDatabase
        print "<html><title>...</title><body>" if DEBUG
        print "<H1>...</H1>"                   if DEBUG
        id = @data.values["id"].to_i
        id = -1 if id==nil
        print "id='#{id.to_s}'"                if DEBUG

        print "<P>Connecting..."                if DEBUG
        db = MarkedDB.new

        print "Connected!"             if DEBUG
        

        # need to validate the data first
        applyControlParameters
        # applyRequiredControlParameters

        if id<0 then #have to generate id and metadata
                id = db.insert
                @data.values["id"]=id.to_s
                print "<P>Inserted! "+ @data.values["id"] + " " +
                        getReplaceValue( "id" )             if DEBUG
        end

        # applyControlParameters
        db.updateSvar( id, @data )
        db.updateMetaSvar( id, @metadata )


        #print "</body></html>\r\n"              if DEBUG
  end



  def applyControlParameters
        data = @ctrldata

        # all text fields must be padded with ' for the update
        txt = data.values["CTRL_text_fields"]
        print "<BR>txt=" + txt if DEBUG && txt!=nil
        
        applyTextFieldControlParameter(txt) if txt!=nil

        


        # required fields must be checked for existance at least
        txt = data.values["CTRL_required_fields"]
        print "<BR>req_txt=" + txt if DEBUG && txt!=nil
        applyRequiredFieldControlParameter(txt) if txt!=nil


  end

  def applyTextFieldControlParameter( txt )

        txtfields = txt.split(' ')

        print "<BR>txtfields=" + txtfields.to_s if DEBUG

        txtfields.each{ |f|
                print "<BR>" + f.to_s if DEBUG
                s = @data.values[f]
                print s.to_s if DEBUG
                if s!=nil then                        
                        # remove any "-s
                        s = s.gsub('"', "'" )               
        
                        # wrap in "
                        s2 = '"'+ s + '"'
                        @data.values[f] = s2
                        print "<BR> " + f + "=" + @data.values[f] if DEBUG
                end
        } if txtfields!=nil
        print "done" if DEBUG

  end

  def applyRequiredFieldControlParameter( txt )

        print "<P>applyRequiredFieldControlParameter"             if DEBUG
        txtfields = txt.split(' ') 

        print "<BR>txtfields=" + txtfields.to_s if DEBUG && txtfields!=nil

        missing = Array.new

        txtfields.each{ |f|
                print "<BR>" + f.to_s if DEBUG
                s = @data.values[f]
                print s.to_s if DEBUG
                if s==nil then                        
                        # a required field isn't there
                        print "<P>FAILURE: missing field: "+f             if DEBUG
                        missing.push( f.to_s )
                        print " *FAILURE* "           if DEBUG
                        
                end
        } if txtfields!=nil



        print "done..." if DEBUG
        if !missing.empty? then
                        print "throwing..." if DEBUG
                raise MissingFieldsException.new(missing) #, "Required fields missing"
        end
        print "done!" if DEBUG


  end


  def notifyAboutMissingFields( missing )
                ctrldata.values["CTRL_missing_fields"] =
                        "<UL><LI>" + missing.join("</LI>\n\t<LI>") +
                        "</UL>\n"
                feedfileout( "html/missing.html" )
                
  end




  def feedfileout( filename )
        if filename==nil then
                filename = "html/error.html"
	else
		filename.untaint #DANGER
        end
        IO.foreach( filename ){|line|
	        print processLine( line )
        }
  end



  def isMeta?(k)   #is a CGI parameter key a meta?
	k  =~"META_"
  end

  def isControl?(k) #is a CGI parameter a control parameter?
	k =~"CTRL_"
  end









  def showAllTables
		print "<html><title>Tables</title><body>"
		print "<H1>Tables</H1>"
        print "<HR>"

	if RELEASE_VERSION then
		raise "This function is disabled in the release version to " +
		        "guard privacy."	

	else        
	       db = MarkedDB.new
	        db.showTable(MarkedDB::METASVAR)
	        db.showTable(MarkedDB::SVAR)
	end
 
        print "<HR>"




		print "</body></html>\r\n"
  end

  def echoParams( param )
		print "<html><title>Echo Paramters</title><body>"
		print "<H1>Echo Parameters!</H1>"
		echo( param )
		print "</body></html>\r\n"
  end

  def echo( param )

	print "<UL>"
	param.each{|a,b|
		x = "<LI> '" + a.to_s + "'='" +b.to_s + "'"
		print x
	}
	print "</UL>"
  end	

end




# Main program

# print "Content-type: text/html\r\n\r\n"
begin #fallback rescue clause: incase even the error html file dies
  begin 
        cgi = CGI.new


        param = cgi.params
        system = Marked.new

        print "<HR>" if DEBUG

        ip = ENV["REMOTE_ADDR"]
        script = ENV["SCRIPT_NAME"]

        ip.untaint #DANGER

        begin
                ip = Socket.gethostbyname( ip )[0].to_s
        rescue StandardError
                # we don't give a toss, lets just have the number then...
        end


        ip = "'" + ip.to_s + "'"    if ip!=nil

        system.ctrldata.values["CTRL_ipaddr"] = ip
        system.ctrldata.values["CTRL_scriptname"] = script


        system.do( cgi )


  rescue StandardError => boom
        ctrl = system.ctrldata.values
        ctrl["CTRL_error"] = boom.to_s
        ctrl["CTRL_error_type"] = boom.type.to_s
        ctrl["CTRL_stack_trace"] = "\n\t " + 
                boom.backtrace.join("\n\t  --&gt; ") +
                "\n"
        system.feedfileout( nil )
  end


rescue StandardError => boom
                print "StandardError:" + boom
end

#print "</body></html>\r\n"
